"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var css_selector_parser_1 = require("css-selector-parser");
var dedent_1 = __importDefault(require("dedent"));
var parser = new css_selector_parser_1.CssSelectorParser();
parser.registerSelectorPseudos('has');
parser.registerNestingOperators('>', '+', '~');
parser.registerAttrEqualityMods('^', '$', '*', '~');
parser.enableSubstitutes();
exports.validateSelector = function (selector) {
    return selector.split(',').map(function (selectorPart) {
        if (selectorPart.indexOf('&') === -1) {
            throw new Error(dedent_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n          Invalid selector: ", "\n      \n          Selectors must target the ampersand character ('&'), which refers to the generated class name, e.g. '&:nth-child(2n)'\n        "], ["\n          Invalid selector: ", "\n      \n          Selectors must target the ampersand character ('&'), which refers to the generated class name, e.g. '&:nth-child(2n)'\n        "])), selector));
        }
        var ampersand = '__treat_ampersand__';
        var selectorAst;
        try {
            selectorAst = parser.parse(selectorPart.replace(/&/g, "." + ampersand));
        }
        catch (err) {
            throw new Error("Invalid selector: " + selector);
        }
        var targetRule = selectorAst;
        while (targetRule.rule) {
            targetRule = targetRule.rule;
        }
        if (!Array.isArray(targetRule.classNames) ||
            !targetRule.classNames.find(function (className) { return className === ampersand; })) {
            throw new Error(dedent_1.default(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n          Invalid selector: ", "\n      \n          Style selectors must end with the '&' character (along with any modifiers), e.g. ", " or ", ".\n          \n          This is to ensure that each style block only affects the styling of a single class.\n          \n          If your selector is targeting another class, you should move it to the style definition for that class, e.g. given we have styles for 'parent' and 'child' elements, instead of adding a selector of ", ") to 'parent', you should add ", " to 'child').\n          \n          If your selector is targeting something global, use the 'globalStyle' function instead, e.g. if you wanted to write ", ", you should instead write 'globalStyle(", ", { ... })'\n        "], ["\n          Invalid selector: ", "\n      \n          Style selectors must end with the '&' character (along with any modifiers), e.g. ", " or ", ".\n          \n          This is to ensure that each style block only affects the styling of a single class.\n          \n          If your selector is targeting another class, you should move it to the style definition for that class, e.g. given we have styles for 'parent' and 'child' elements, instead of adding a selector of ", ") to 'parent', you should add ", " to 'child').\n          \n          If your selector is targeting something global, use the 'globalStyle' function instead, e.g. if you wanted to write ", ", you should instead write 'globalStyle(", ", { ... })'\n        "])), selector, '`${parent} &`', '`${parent} &:hover`', '`& ${child}`', '`${parent} &`', '`& h1`', '`${parent} h1`'));
        }
    });
};
var templateObject_1, templateObject_2;
